
rm(list=ls())
library(doParallel)
library(kernlab)
library(MASS)

setwd("/Users/melody/Dropbox/Project2/ExampleCode")
source("HINGE_SVM.R")
source("RAMP_SVM.R")
source("temp_split.R")
#refit by different domains
source("temp_Node_refit_v2.R")
source("CITree.R")

min.N1=25
min.N2=25
FDR=0.1
N = 1000

mu=matrix(c(1, -0.5, 1, 0), byrow=T, nrow=2)
c=c(-0.3, -0.1)
beta=c(1,-0.5, 0.5)
r=0.5
nsim = 100



data.set1 <- function(N){
  A <- sample(c(1, -1), N, replace=T) 
  X1 <- rnorm (N)
  X2 <- rnorm(N)
  X3 <- rnorm (N)
  X4 <- rnorm(N)
  X5 <- rnorm(N)
  X6 <- rnorm(N)
  
  f1 <- X1 + X2 - 0.5
  f2 <- X4 + X3 
  theta2R <- -(f2 <=0 ) + (1 - 0.5 * (X3 <= 0.3)) * (f2 > 0)  
  #theta2R <- 1
  theta1L <- mu[1,1] * (X1 <= c[1]) + mu[1,2] * (X1 > c[1]) * theta2R
  theta1R <- mu[2,1] + mu[2,2] * (X2 > c[2])
  Phi1L <- theta1L * (f1 <= 0)
  Phi1R <- theta1R * (f1 > 0)
  PHI1 <- A * (Phi1R - Phi1L)
  
  #Y <- X1 - 0.5 * X2 + PHI1 + rnorm(N) * 0.5# + X3 * 0.4 - X4 * 0.5 
  Y <- beta[1] * X1 + beta[2] * X2 + PHI1 + r * rnorm(N) + beta[3] * X3 - X4*0.5 + 0.5 *X5
  Z <- sign((Phi1R - Phi1L))
  X <- cbind(X1, X2, X3, X4, X5, X6)
  #sum(f1<=0 & X1<=c[1])
  #sum(f1<=0& X1>c[1] & f2<=0 )
  #sum(f1<=0 & X1>c[1]&f2>0 & X3<=0.3)
  #sum(f1<=0 & X1>c[1]&f2>0 & X3>0.3)
  #sum(f1>0)
  #ture terminal node
  Index <- (f1<=0 & X1<=c[1]) + (f1<=0& X1>c[1] & f2<=0 ) * 2 + (f1<=0 & X1>c[1]&f2>0 & X3<=0.3)*3 + (f1<=0 & X1>c[1]&f2>0 & X3>0.3) *4 + (f1>0) * 5  
  
  PrTx <- (A == 1) * sum(A==1)/N + (A == -1) * sum(A == -1)/N
  true_benefit = mean(Y*(Z==A)/PrTx-Y*(Z!=A)/PrTx)
  #data <- data.frame(X=X, Y=Y, A=A, PrTx=PrTx, Z=Z, true_node=Index)
  return(list(X=X, Y=Y, A=A, PrTx=PrTx, Z=Z, Index=Index))
}

#set.seed(241432)
set.seed(42143212)
validate <- data.set1(10000)
validate.QUINT <- data.frame(validate)
validate.IT <- data.frame(X=validate$X, y=validate$Y, trt=(validate$A+1)/2 )

ITR_ben(validate$Y, validate$PrTx, validate$A, validate$Z)


#set.seed(241432)
set.seed(42143212)


# First, generate a data set
data <- data.set1(N=2000)
X <- data$X
Y <- data$Y
A <- data$A
PrTx <- data$PrTx
Z <- data$Z
Index <- data$Index

ind <- sample(1:2, length(Y), replace=T)
#training set is for fitting hat f and testing set is for estimating benefit
Ytrain <- Y[ind!=1]; Xtrain <- X[ind!=1,]; Atrain <- A[ind!=1]; PTtrain <- PrTx[ind!=1];
Ytest <- Y[ind==1]; Xtest <- X[ind==1,];  Atest <- A[ind==1]; PTtest <- PrTx[ind==1]; Ztest <- Z[ind==1]; 
Indextest <- Index[ind==1]


#RAMPO
#fit <- RAMP_SVM(X, A, Y, PrTx, C=1, s=1, newX=validate$X, iter.Max=20, tol=0.0001) 
#benefit_rampo <- ITR_ben(validate$Y, validate$PrTx, validate$A, fit$ITR)
#accuracy_rampo <- mean(validate$Z==fit$ITR)

#honst tree
root_node <- CITree(Ytrain, Xtrain, Atrain, PTtrain, Ytest, Xtest, Atest, PTtest, maxL=2, iter.Max=20, C=1, s=1, tol=.0001) 
honest_ITR <- CITree.predict(root_node$root, newX=validate$X)
accuracy_tree1 <- mean(honest_ITR$ITR==validate$Z)
benefit_tree1 <- ITR_ben(validate$Y, validate$PrTx, validate$A, honest_ITR$ITR)

#unhonest tree
root_node2 <- CITree(Y, X, A, PrTx, Y, X, A, PrTx, maxL=8, iter.Max=20, C=1, s=1, tol=.0001)
unhonest_ITR <- CITree.predict(root_node2$root, newX=validate$X)
accuracy_tree2 <- mean(unhonest_ITR$ITR==validate$Z)
benefit_tree2 <- ITR_ben(validate$Y, validate$PrTx, validate$A, unhonest_ITR$ITR)

