##Feb 21 2017 Update: name nodes by adding 1 for left nodes and 2 for right nodes
## 1 is root node, 11 is the left node and 12 is the right ndoe ....
## Given the node name, we are able to locate the node in a tree structure
## The digit of node name represents the level and 1 2 represents right or left

####this is a temp nodeAtoB and nodeBtoA script####
####Variables are selected to fit RAMPO at each stage####
####For each split, all varialbes will be considered ####

# Set up reference class
#trainInd: indicator variable to indicate if subject is included in this node as training data
#testInd: indicator variable to indicate if subject is indlcuded in this node as testing data
#ITRtrain: predicted ITR for training set after operation in the current node
#ITRtest: predicted ITR for testing set after operation in the current node
#benefit: ITR benefit of the current node
#beta: hat beta for the current node
#candiate: exclude variables that have been considered as splitpoint in previous levels

Tree <- setRefClass("Tree")

Empty <- setRefClass("Empty", contains="Tree")

InternalA <- setRefClass("InternalA", contains="Tree",
                         fields=list(trainInd="vector", testInd="vector", ITRtrain="vector", ITRtest="vector", beta="vector", benefit="numeric", candidate="vector", left="Tree", right="Tree", nodeName="character"))
InternalB <-setRefClass("InternalB", contains="Tree",
                        fields=list(trainInd="vector", testInd="vector", ITRtrain="vector", ITRtest="vector",  beta="vector", benefit="numeric", cutoff="ANY", candidate="vector", left="Tree", right="Tree", nodeName="character"))


#Q:Ytest, PTtest are global variables
#Node A to B: based on sign(hat f), split to B1 B2 
#Add stopping rules, consider if B1 or B2 is empty
#Add test data and training data into the function as local varaibles
nodeA_to_B <- function(nodeA_list, Ytrain, Xtrain, Atrain, PTtrain, Ytest, Xtest, Atest, PTtest){
  i <- 1
  j <- 1
  nodeB_list <- list()
  #while (nodeA in nodeA_list){
  while (j <= length(nodeA_list)){
    nodeA <- nodeA_list[[j]]
    #check if B1 and B2 are empty, do not split if at least one are empty
    if (sum(nodeA$ITRtrain[nodeA$trainInd==1]==-1)!=0 & 
          sum(nodeA$ITRtest[nodeA$testInd==1]==-1)!=0 & 
          sum(nodeA$ITRtrain[nodeA$trainInd==1]==1)!=0 & 
          sum(nodeA$ITRtest[nodeA$testInd==1]==1)!=0 ) {
      # patients with predicted ITR=-1 and in nodeA should be included
      trainB1 <- (nodeA$ITRtrain==-1) & (nodeA$trainInd==1)
      testB1 <- (nodeA$ITRtest==-1) & (nodeA$testInd==1) 
      benefitB1 <- ITR_ben(Ytest[testB1==1], PTtest[testB1==1], Atest[testB1==1], nodeA$ITRtest[testB1==1])
      nodeB1 <- InternalB$new(trainInd=trainB1, testInd=testB1, ITRtrain=nodeA$ITRtrain, ITRtest=nodeA$ITRtest,  beta=nodeA$beta, benefit=benefitB1, candidate=nodeA$candidate, nodeName=paste0(nodeA$nodeName, "1"))
      nodeA$left <- nodeB1  
      nodeB_list[[i]] <- nodeB1
      i <- i + 1
      
      trainB2 <- (nodeA$ITRtrain==1) & (nodeA$trainInd==1)
      testB2 <- (nodeA$ITRtest==1) & (nodeA$testInd==1)
      benefitB2 <- ITR_ben(Ytest[testB2==1], PTtest[testB2==1], Atest[testB2==1], nodeA$ITRtest[testB2==1])  
      nodeB2 <- InternalB$new(trainInd=trainB2, testInd=testB2,ITRtrain=nodeA$ITRtrain, ITRtest=nodeA$ITRtest, beta=nodeA$beta, benefit=benefitB2, candidate=nodeA$candidate, nodeName=paste0(nodeA$nodeName, "2"))
      nodeA$right <- nodeB2
      nodeB_list[[i]] <- nodeB2
      i <- i + 1
    }
    j <- j + 1
  }
  return(nodeB_list)
}


#Updated on Nov 20, refit f hat only on selected variables
#re-fit f hat and re-save nodeA 
nodeA_fit <- function(nodeA, Ytrain, Xtrain, Atrain, PTtrain, Ytest, Xtest, Atest, PTtest){
  #fit hat f by finding the tuning parameters
  #tune_param <- RAMP.CV(Xtrain[nodeA$trainInd==1,], Atrain[nodeA$trainInd==1], Ytrain[nodeA$trainInd==1], PTtrain[nodeA$trainInd==1], bigC, bigS, K, iter.Max, tol)
  fit <- RAMP_SVM(X=Xtrain[nodeA$trainInd==1, ], A=Atrain[nodeA$trainInd==1], Y=Ytrain[nodeA$trainInd==1], PrTx=PTtrain[nodeA$trainInd==1], C=1, s=1, newX=Xtrain, iter.Max=20, tol=0.0001)
  #fit <- HINGE_SVM(Xtrain[nodeA$trainInd==1,], Atrain[nodeA$trainInd==1], Ytrain[nodeA$trainInd==1], PTtrain[nodeA$trainInd==1], C=1, newX=Xtrain)
  
  #if in the node A, then predicted ITR should be updated; OW, keep the old value
  ITRtrain <- (nodeA$trainInd==1) * fit$ITR + (nodeA$trainInd==0) * nodeA$ITRtrain
  ITRtest <- (nodeA$testInd==1) * RAMP_SVM.pred (fit, Xtest) + (nodeA$testInd==0) * nodeA$ITRtest
  benefit <- ITR_ben(Ytest[nodeA$testInd==1], PTtest[nodeA$testInd==1], Atest[nodeA$testInd==1], ITRtest[nodeA$testInd==1])  
  #use the re-fitted hat f only if benefit increases
  if (benefit > nodeA$benefit) {
    nodeA$beta <- c(fit$e.beta0,fit$e.beta)
    print(nodeA$beta)
    nodeA$ITRtrain <- ITRtrain
    nodeA$ITRtest <- ITRtest
    nodeA$benefit <- benefit
  }
  return(nodeA)
}

#######################################################################
###This part was updated in order to save all the info of splitting####
#######################################################################
#Based on B, split to A1 A2 by the variable with smallest p-value<0.05
nodeB_to_A <- function(root, nodeB_list, Ytrain, Xtrain, Atrain, PTtrain, Ytest, Xtest, Atest, PTtest){
  #Ytest <- TestData$Y; Atest <- TestData$A; Xtest <- TestData$X; PTtest <- TestData$PrTx;
  #Ytrain <- TrainData$Y; Atrain <- TrainData$A; Xtrain <- TrainData$X; PTtrain <- TrainData$PrTx;
  i <- 1
  j <- 1
  nodeA_list <- list()
  # while (nodeB in nodeB_list){
  while (j <= length(nodeB_list)){
    nodeB <- nodeB_list[[j]]
    sub <- nodeB$testInd #indicator of test set
    #update: for calculating FDR and PPV
    #update: Nov 28: to check the size of test set to avoid useless spittting
    if(sum(nodeB$testInd) > min.N2){ 
      #result <- best_split(X=Xtest[sub,], candidate=nodeB$candidate, A=Atest[sub], ITR=nodeB$ITRtest[sub], PrTx=PTtest[sub], Y=Ytest[sub])
      result_temp <- best_split(X=Xtest[sub,], candidate=nodeB$candidate, A=Atest[sub], ITR=nodeB$ITRtest[sub], PrTx=PTtest[sub], Y=Ytest[sub])
      result <- result_temp$best
      
      candi_temp <- nodeB$candidate
      
      #determine whether to split by adjusted p-value
      #derermine the split point by unadjusted p-value
      if (result_temp$adjusted.p < FDR ){
        variable <- result[1]
        splitpoint <- result[2]
        #varaible should be excluded from list of candidate variables
        candi_temp[variable] <- 0
        trainA1 <- (nodeB$trainInd==1) & (Xtrain[,variable] <= splitpoint) 
        trainA2 <- (nodeB$trainInd==1) & (Xtrain[,variable] > splitpoint)
        testA1 <- (nodeB$testInd==1) & (Xtest[,variable] <= splitpoint)
        testA2 <- (nodeB$testInd==1) & (Xtest[,variable] > splitpoint)
        benefitA1 <- ITR_ben(Ytest[testA1==1], PTtest[testA1==1], Atest[testA1==1], nodeB$ITRtest[testA1==1])
        benefitA2 <- ITR_ben(Ytest[testA2==1], PTtest[testA2==1], Atest[testA2==1], nodeB$ITRtest[testA2==1])  
        
        nodeA1 <- InternalA$new(trainInd=trainA1, testInd=testA1, ITRtrain=nodeB$ITRtrain, ITRtest=nodeB$ITRtest, beta=nodeB$beta, benefit=benefitA1, candidate=candi_temp, nodeName=paste0(nodeB$nodeName, "1"))
        nodeA2 <- InternalA$new(trainInd=trainA2, testInd=testA2, ITRtrain=nodeB$ITRtrain, ITRtest=nodeB$ITRtest, beta=nodeB$beta, benefit=benefitA2, candidate=candi_temp, nodeName=paste0(nodeB$nodeName, "2"))
        #update: for calculating FDR and PPV
        nodeB$cutoff <- result
               
        #check whether we should re-fit another hat f for any nodeA
        #notice if both nodeA1 and nodeA2 were refitted, updated ITRtrain for nodeA2 won't be reflected in ITRtrain for nodeA1, but this is fine since subjects in nodeA1 and A2 are exclusive
        #Update nodeA$ITR to reflect the ITR under the current node: nodeA$ITR is the final predicted ITR after last split
        if (sum(nodeA1$trainInd) > min.N1 & sum(nodeA1$testInd) > min.N2){
          nodeA1 <- nodeA_fit(nodeA1, Ytrain, Xtrain, Atrain, PTtrain, Ytest, Xtest, Atest, PTtest)
          root$ITRtrain <- (1 - nodeA1$trainInd) * root$ITRtrain + nodeA1$trainInd * nodeA1$ITRtrain
          root$ITRtest <- (1 - nodeA1$testInd) * root$ITRtest + nodeA1$testInd * nodeA1$ITRtest
        }   
        if (sum(nodeA2$trainInd) > min.N1 & sum(nodeA2$testInd) > min.N2){
          nodeA2 <- nodeA_fit(nodeA2, Ytrain, Xtrain, Atrain, PTtrain, Ytest, Xtest, Atest, PTtest)
          root$ITRtrain <- (1 - nodeA2$trainInd) * root$ITRtrain + nodeA2$trainInd * nodeA2$ITRtrain
          root$ITRtest <- (1 - nodeA2$testInd) * root$ITRtest + nodeA2$testInd * nodeA2$ITRtest 
        }  
        nodeB$left <- nodeA1
        nodeB$right <- nodeA2
        nodeA_list[[i]] <- nodeA1
        nodeA_list[[i+1]] <- nodeA2
        i <- i + 2
      } 
    }
    j <- j + 1 
  }
  return (nodeA_list)
}

